9ae3a8
From 119ce531952beab96a8b807721e2180d99382073 Mon Sep 17 00:00:00 2001
9ae3a8
From: Jeffrey Cody <jcody@redhat.com>
9ae3a8
Date: Wed, 29 Jul 2015 16:59:55 +0200
9ae3a8
Subject: [PATCH 04/13] block: qemu-iotests - add check for multiplication
9ae3a8
 overflow in vpc
9ae3a8
9ae3a8
Message-id: <9e859f3912d1852e48fb7e25a3679bd74500c36d.1438188988.git.jcody@redhat.com>
9ae3a8
Patchwork-id: 67198
9ae3a8
O-Subject: [RHEL-7.2 qemu-kvm PATCH 3/3] block: qemu-iotests - add check for multiplication overflow in vpc
9ae3a8
Bugzilla: 1217349
9ae3a8
RH-Acked-by: Laszlo Ersek <lersek@redhat.com>
9ae3a8
RH-Acked-by: Stefan Hajnoczi <stefanha@redhat.com>
9ae3a8
RH-Acked-by: Max Reitz <mreitz@redhat.com>
9ae3a8
9ae3a8
This checks that VPC is able to successfully fail (without segfault)
9ae3a8
on an image file with a max_table_entries that exceeds 0x40000000.
9ae3a8
9ae3a8
This table entry is within the valid range for VPC (although too large
9ae3a8
for this sample image).
9ae3a8
9ae3a8
Cc: qemu-stable@nongnu.org
9ae3a8
Signed-off-by: Jeff Cody <jcody@redhat.com>
9ae3a8
Signed-off-by: Kevin Wolf <kwolf@redhat.com>
9ae3a8
(cherry picked from commit 77c102c26ead946fe7589d4bddcdfa5cb431ebfe)
9ae3a8
Signed-off-by: Miroslav Rezanina <mrezanin@redhat.com>
9ae3a8
9ae3a8
Conflicts:
9ae3a8
	tests/qemu-iotests/group
9ae3a8
9ae3a8
Signed-off-by: Jeff Cody <jcody@redhat.com>
9ae3a8
---
9ae3a8
 tests/qemu-iotests/135     | 54 ++++++++++++++++++++++++++++++++++++++++++++++
9ae3a8
 tests/qemu-iotests/135.out |  5 +++++
9ae3a8
 tests/qemu-iotests/group   |  1 +
9ae3a8
 3 files changed, 60 insertions(+)
9ae3a8
 create mode 100755 tests/qemu-iotests/135
9ae3a8
 create mode 100644 tests/qemu-iotests/135.out
9ae3a8
9ae3a8
diff --git a/tests/qemu-iotests/135 b/tests/qemu-iotests/135
9ae3a8
new file mode 100755
9ae3a8
index 0000000..16bf736
9ae3a8
--- /dev/null
9ae3a8
+++ b/tests/qemu-iotests/135
9ae3a8
@@ -0,0 +1,54 @@
9ae3a8
+#!/bin/bash
9ae3a8
+#
9ae3a8
+# Test VPC open of image with large Max Table Entries value.
9ae3a8
+#
9ae3a8
+# Copyright (C) 2015 Red Hat, Inc.
9ae3a8
+#
9ae3a8
+# This program is free software; you can redistribute it and/or modify
9ae3a8
+# it under the terms of the GNU General Public License as published by
9ae3a8
+# the Free Software Foundation; either version 2 of the License, or
9ae3a8
+# (at your option) any later version.
9ae3a8
+#
9ae3a8
+# This program is distributed in the hope that it will be useful,
9ae3a8
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
9ae3a8
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
9ae3a8
+# GNU General Public License for more details.
9ae3a8
+#
9ae3a8
+# You should have received a copy of the GNU General Public License
9ae3a8
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
9ae3a8
+#
9ae3a8
+
9ae3a8
+# creator
9ae3a8
+owner=jcody@redhat.com
9ae3a8
+
9ae3a8
+seq=`basename $0`
9ae3a8
+echo "QA output created by $seq"
9ae3a8
+
9ae3a8
+here=`pwd`
9ae3a8
+tmp=/tmp/$$
9ae3a8
+status=1	# failure is the default!
9ae3a8
+
9ae3a8
+_cleanup()
9ae3a8
+{
9ae3a8
+    _cleanup_test_img
9ae3a8
+}
9ae3a8
+trap "_cleanup; exit \$status" 0 1 2 3 15
9ae3a8
+
9ae3a8
+# get standard environment, filters and checks
9ae3a8
+. ./common.rc
9ae3a8
+. ./common.filter
9ae3a8
+
9ae3a8
+_supported_fmt vpc
9ae3a8
+_supported_proto generic
9ae3a8
+_supported_os Linux
9ae3a8
+
9ae3a8
+_use_sample_img afl5.img.bz2
9ae3a8
+
9ae3a8
+echo
9ae3a8
+echo "=== Verify image open and failure ===="
9ae3a8
+$QEMU_IMG info "$TEST_IMG" 2>&1| _filter_testdir
9ae3a8
+
9ae3a8
+# success, all done
9ae3a8
+echo "*** done"
9ae3a8
+rm -f $seq.full
9ae3a8
+status=0
9ae3a8
diff --git a/tests/qemu-iotests/135.out b/tests/qemu-iotests/135.out
9ae3a8
new file mode 100644
9ae3a8
index 0000000..793898b
9ae3a8
--- /dev/null
9ae3a8
+++ b/tests/qemu-iotests/135.out
9ae3a8
@@ -0,0 +1,5 @@
9ae3a8
+QA output created by 135
9ae3a8
+
9ae3a8
+=== Verify image open and failure ====
9ae3a8
+qemu-img: Could not open 'TEST_DIR/afl5.img': Max Table Entries too large (1073741825)
9ae3a8
+*** done
9ae3a8
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
9ae3a8
index 0644c42..58b3d05 100644
9ae3a8
--- a/tests/qemu-iotests/group
9ae3a8
+++ b/tests/qemu-iotests/group
9ae3a8
@@ -92,3 +92,4 @@
9ae3a8
 114 rw auto quick
9ae3a8
 121 rw auto
9ae3a8
 130 rw auto quick
9ae3a8
+135 rw auto
9ae3a8
-- 
9ae3a8
1.8.3.1
9ae3a8